# file      : build/cxx/intel/o-l.make
# author    : Boris Kolpackov <boris@kolpackov.net>
# copyright : Copyright (c) 2004 Boris Kolpackov
# license   : GNU GPL v2; see accompanying LICENSE file

$(call include,$(bld_root)/cxx/intel/configuration.make)

vpath %.a $(cxx_intel_libraries)
vpath %.so $(cxx_intel_libraries)

ifdef c_lib_type

.PHONY: $(out_root)/%.l.clean

ifeq ($(c_lib_type),archive)

$(out_root)/%.l: ar ?= ar
$(out_root)/%.l: ar_options ?= -rc

$(out_root)/%.l: | $$(dir $$@).
	$(call message,"ar  $@",$(ar) $(ar_options) $(@D)/lib$(basename $(@F)).a $(filter %.o,$^) && \
echo $(@D)/lib$(basename $(@F)).a >$@ && \
echo $(cpp_options) >>$@ && \
echo "$(patsubst %.l,`cat %.l`,$(filter %.a %.so %.l,$^))" >>$@)


$(out_root)/%.l.clean:
	$(call message,rm $(basename $@),rm -f $(basename $@) $(@D)/$(patsubst %.l.clean,lib%.a,$(@F)))

else

$(out_root)/%.l: ld := $(cxx_intel)
$(out_root)/%.l: ld_options := $(cxx_intel_optimization_options) $(cxx_intel_debugging_options)
$(out_root)/%.l: comma_ := ,
$(out_root)/%.l: cxx_pic_options := -fPIC

$(out_root)/%.l: | $$(dir $$@).
	$(call message,"ld  $@",$(ld) -shared $(ld_options) \
-o $(@D)/lib$(basename $(@F)).so -Wl$(comma_)-soname=lib$(basename $(@F)).so \
$(foreach f,$^,$(if $(patsubst %.l,,$f),$f,$(shell sed -e '/^-I/ d' $f))) && \
echo $(@D)/lib$(basename $(@F)).so >$@ && \
echo -Wl$(comma_)-rpath$(comma_)$(@D) >>$@ && \
echo $(cpp_options) >>$@ && \
echo "$(patsubst %.l,`cat %.l`,$(filter %.a %.so %.l,$^))" >>$@)

$(out_root)/%.l.clean:
	$(call message,rm $(basename $@),rm -f $(basename $@) $(@D)/$(patsubst %.l.clean,lib%.so,$(@F)))

endif
endif
